package dev.shadowsoffire.apotheosis.potion.compat;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.ench.compat.EnchantingCategory;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingRecipe;
import dev.shadowsoffire.apotheosis.potion.PotionCharmItem;
import dev.shadowsoffire.apotheosis.potion.PotionEnchantingRecipe;
import dev.shadowsoffire.apotheosis.potion.compat.PotionJEIPlugin;
import java.util.ArrayList;
import java.util.List;
import mezz.jei.api.constants.VanillaTypes;
import mezz.jei.api.gui.builder.IIngredientAcceptor;
import mezz.jei.api.gui.builder.IRecipeLayoutBuilder;
import mezz.jei.api.gui.builder.IRecipeSlotBuilder;
import mezz.jei.api.ingredients.IIngredientType;
import mezz.jei.api.ingredients.ITypedIngredient;
import mezz.jei.api.recipe.IFocus;
import mezz.jei.api.recipe.IFocusGroup;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.alchemy.Potion;
import net.minecraft.world.item.alchemy.PotionUtils;
import net.minecraft.world.level.ItemLike;
import net.minecraftforge.registries.ForgeRegistries;

class PotionCharmEnchantingWrapper implements EnchantingCategory.Extension<PotionEnchantingRecipe> {
  public void setRecipe(IRecipeLayoutBuilder builder, IRecipeSlotBuilder input, IRecipeSlotBuilder output, EnchantingRecipe recipe, IFocusGroup focuses) {
    ItemStack stack = focuses.getFocuses((IIngredientType)VanillaTypes.ITEM_STACK).findFirst().map(IFocus::getTypedValue).map(ITypedIngredient::getIngredient).orElse(ItemStack.f_41583_);
    if (PotionCharmItem.hasEffect(stack)) {
      ItemStack in = stack.m_41777_();
      in.m_41784_().m_128379_("Unbreakable", false);
      ItemStack out = stack.m_41777_();
      out.m_41784_().m_128379_("Unbreakable", true);
      input.addIngredient((IIngredientType)VanillaTypes.ITEM_STACK, in);
      output.addIngredient((IIngredientType)VanillaTypes.ITEM_STACK, out);
    } else {
      List<ItemStack> potionStacks = new ArrayList<>();
      List<ItemStack> unbreakable = new ArrayList<>();
      for (Potion p : ForgeRegistries.POTIONS) {
        if (!PotionCharmItem.isValidPotion(p))
          continue; 
        ItemStack charm = new ItemStack((ItemLike)Apoth.Items.POTION_CHARM.get());
        PotionUtils.m_43549_(charm, p);
        potionStacks.add(charm);
        ItemStack copy = charm.m_41777_();
        copy.m_41784_().m_128379_("Unbreakable", true);
        unbreakable.add(copy);
      } 
      input.addIngredients((IIngredientType)VanillaTypes.ITEM_STACK, potionStacks);
      output.addIngredients((IIngredientType)VanillaTypes.ITEM_STACK, unbreakable);
    } 
    builder.createFocusLink(new IIngredientAcceptor[] { (IIngredientAcceptor)input, (IIngredientAcceptor)output });
  }
}
